VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Melan's Theorem evaluator"
   ClientHeight    =   7170
   ClientLeft      =   4485
   ClientTop       =   2700
   ClientWidth     =   7950
   Icon            =   "Evaluator.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7170
   ScaleWidth      =   7950
   Begin VB.Frame Frame2 
      Caption         =   "Auto-compute Yield stress"
      Height          =   1335
      Left            =   5520
      TabIndex        =   21
      Top             =   2400
      Width           =   2175
      Begin VB.OptionButton autoNo 
         Caption         =   "No"
         Height          =   375
         Left            =   480
         TabIndex        =   23
         Top             =   720
         Value           =   -1  'True
         Width           =   1215
      End
      Begin VB.OptionButton autoYes 
         Caption         =   "Yes"
         Height          =   255
         Left            =   480
         TabIndex        =   22
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.TextBox alphaStep 
      Height          =   375
      Left            =   1800
      TabIndex        =   20
      Text            =   "0.01"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.Frame Frame1 
      Caption         =   "Yield Criteria"
      Height          =   1335
      Left            =   3120
      TabIndex        =   10
      Top             =   2400
      Width           =   2175
      Begin VB.OptionButton crit2 
         Caption         =   "Tresca's criteria"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   840
         Width           =   1695
      End
      Begin VB.OptionButton crit1 
         Caption         =   "Von Mises criteria"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Value           =   -1  'True
         Width           =   1815
      End
   End
   Begin VB.TextBox yldStrs 
      Height          =   375
      Left            =   1800
      TabIndex        =   8
      Top             =   2640
      Width           =   1095
   End
   Begin VB.CommandButton calculate 
      Caption         =   "Calculate Alpha and Beta"
      Height          =   615
      Left            =   3120
      TabIndex        =   7
      Top             =   4320
      Width           =   2055
   End
   Begin VB.CommandButton browse2 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   5520
      TabIndex        =   5
      Top             =   1200
      Width           =   1215
   End
   Begin VB.TextBox linearlyElastic 
      Height          =   375
      Left            =   2280
      TabIndex        =   4
      Top             =   1200
      Width           =   3135
   End
   Begin MSComDlg.CommonDialog CommonDialog 
      Left            =   3960
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton browse1 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.TextBox elasticPerfPlastic 
      Height          =   405
      Left            =   2280
      TabIndex        =   0
      Top             =   720
      Width           =   3135
   End
   Begin VB.Label Label8 
      Caption         =   "alpha search steps:"
      Height          =   255
      Left            =   360
      TabIndex        =   19
      Top             =   3240
      Width           =   1455
   End
   Begin VB.Label nodesNoLab 
      Height          =   255
      Left            =   2640
      TabIndex        =   18
      Top             =   5520
      Width           =   1095
   End
   Begin VB.Label Label7 
      Caption         =   "no. of nodes:"
      Height          =   255
      Left            =   1560
      TabIndex        =   17
      Top             =   5520
      Width           =   975
   End
   Begin VB.Label betaLab 
      Height          =   255
      Left            =   2640
      TabIndex        =   16
      Top             =   6240
      Width           =   1815
   End
   Begin VB.Label alphaLab 
      Height          =   255
      Left            =   2640
      TabIndex        =   15
      Top             =   6600
      Width           =   4455
   End
   Begin VB.Label Label6 
      Caption         =   "beta = "
      Height          =   255
      Left            =   1560
      TabIndex        =   14
      Top             =   6240
      Width           =   735
   End
   Begin VB.Label Label5 
      Caption         =   "alpha = "
      Height          =   255
      Left            =   1560
      TabIndex        =   13
      Top             =   6600
      Width           =   735
   End
   Begin VB.Label Label4 
      Caption         =   "Yield stress:"
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   2640
      Width           =   975
   End
   Begin VB.Label Label3 
      Caption         =   "Linearly Elastic:"
      Height          =   255
      Left            =   480
      TabIndex        =   6
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Stress field files exported from Ansys:"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   240
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Elastic-perfectly plastic:"
      Height          =   255
      Left            =   480
      TabIndex        =   1
      Top             =   840
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False



Private Sub Browse1_Click()
CommonDialog.FileName = App.Path + "\exported stress field\Elastic-Perfectly Plastic stress field"
CommonDialog.Filter = "List file (*.lis)|*.lis"
CommonDialog.ShowOpen
elasticPerfPlastic.Text = CommonDialog.FileName
End Sub


Private Sub browse2_Click()
CommonDialog.FileName = App.Path + "\exported stress field\Linear Elastic stress field"
CommonDialog.Filter = "List file (*.lis)|*.lis"
CommonDialog.ShowOpen
linearlyElastic.Text = CommonDialog.FileName
End Sub


Private Sub calculate_Click()
' 1 -- Elastic perfectly plastic
' 2 -- Linearly elastic
Dim nodes1() As Long, sx1() As Double, sy1() As Double, sz1() As Double, sxy1() As Double, syz1() As Double, szx1() As Double, nodesNo1 As Long
Dim nodes2() As Long, sx2() As Double, sy2() As Double, sz2() As Double, sxy2() As Double, syz2() As Double, szx2() As Double, nodesNo2 As Long
' 3 -- residual (self-equilabrating) stress field
Dim nodesNo As Long
Dim sx3() As Double, sy3() As Double, sz3() As Double, sxy3() As Double, syz3() As Double, szx3() As Double
Dim tmpSx As Double, tmpSy As Double, tmpSz As Double, tmpSxy As Double, tmpSyz As Double, tmpSzx As Double, tmpNode As Integer

Dim beta As Double, alpha As Double
Dim yieldStress As Double, eqvStressValue As Double, probableBeta As Double, tmpYeld As Double
Dim readline As String, a As Long, b As Long, quryAns As Integer, foundNode As Boolean
Dim minAlpha() As Double, maxAlpha() As Double, thisAlpha As Double, highAlpha As Double, lowAlpha As Double, isAlpha As Boolean

' --------------------------
ReDim nodes1(1000), nodes2(1000)
ReDim sx1(1000), sy1(1000), sz1(1000), sxy1(1000), syz1(1000), szx1(1000)
ReDim sx2(1000), sy2(1000), sz2(1000), sxy2(1000), syz2(1000), szx2(1000)
' --------------------------

Open elasticPerfPlastic.Text For Input As #1


nodesNo1 = 0
Do
    Line Input #1, readline
    If Not (Val(Trim(Mid(readline, 1, 8))) = 0) Then
        nodesNo1 = nodesNo1 + 1
        nodes1(nodesNo1) = Val(Trim(Mid(readline, 1, 8)))
        sx1(nodesNo1) = Val(Trim(Mid(readline, 10, 12)))
        sy1(nodesNo1) = Val(Trim(Mid(readline, 22, 12)))
        sz1(nodesNo1) = Val(Trim(Mid(readline, 34, 12)))
        sxy1(nodesNo1) = Val(Trim(Mid(readline, 46, 12)))
        syz1(nodesNo1) = Val(Trim(Mid(readline, 58, 12)))
        szx1(nodesNo1) = Val(Trim(Mid(readline, 70, 12)))
    End If
    If nodesNo1 Mod 1000 = 0 Then
        ReDim Preserve nodes1(nodesNo1 + 1000)
        ReDim Preserve sx1(nodesNo1 + 1000)
        ReDim Preserve sy1(nodesNo1 + 1000)
        ReDim Preserve sz1(nodesNo1 + 1000)
        ReDim Preserve sxy1(nodesNo1 + 1000)
        ReDim Preserve syz1(nodesNo1 + 1000)
        ReDim Preserve szx1(nodesNo1 + 1000)
    End If
Loop Until EOF(1)

Close #1

' --------------------------

Open linearlyElastic.Text For Input As #1

nodesNo2 = 0
Do
    Line Input #1, readline
    If Not (Val(Trim(Mid(readline, 1, 8))) = 0) Then
        nodesNo2 = nodesNo2 + 1
        nodes2(nodesNo2) = Val(Trim(Mid(readline, 1, 8)))
        sx2(nodesNo2) = Val(Trim(Mid(readline, 10, 12)))
        sy2(nodesNo2) = Val(Trim(Mid(readline, 22, 12)))
        sz2(nodesNo2) = Val(Trim(Mid(readline, 34, 12)))
        sxy2(nodesNo2) = Val(Trim(Mid(readline, 46, 12)))
        syz2(nodesNo2) = Val(Trim(Mid(readline, 58, 12)))
        szx2(nodesNo2) = Val(Trim(Mid(readline, 70, 12)))
    End If
    If nodesNo2 Mod 1000 = 0 Then
        ReDim Preserve nodes2(nodesNo2 + 1000)
        ReDim Preserve sx2(nodesNo2 + 1000)
        ReDim Preserve sy2(nodesNo2 + 1000)
        ReDim Preserve sz2(nodesNo2 + 1000)
        ReDim Preserve sxy2(nodesNo2 + 1000)
        ReDim Preserve syz2(nodesNo2 + 1000)
        ReDim Preserve szx2(nodesNo2 + 1000)
    End If
Loop Until EOF(1)

Close #1

' --------------------------

If Not (nodesNo1 = nodesNo2) Then
    MsgBox "Error!! Unequal Number of nodes!!", vbCritical + vbOKOnly
    Exit Sub
End If
nodesNo = nodesNo1
nodesNoLab.Caption = Str(nodesNo)
For a = 1 To nodesNo
    If Not (nodes1(a) = nodes2(a)) Then
        quryAns = MsgBox("The positions of nodes " + Str(nodes1(a)) + " in the files are not matching!!" + Chr(13) + "Rearrange and continue anyway?", vbExclamation + vbYesNo, "Possible error in file")
        If quryAns = vbNo Then
            Exit Sub
        End If
        foundNode = False
        For b = 1 To nodesNo
            If nodes2(b) = nodes1(a) Then
                '' swap items 'a' and 'b' of '2'
                tmpNode = nodes2(a)
                tmpSx = sx2(a)
                tmpSy = sy2(a)
                tmpSz = sz2(a)
                tmpSxy = sxy2(a)
                tmpSyz = syz2(a)
                tmpSzx = szx2(a)
                nodes2(a) = nodes2(b)
                sx2(a) = sx2(b)
                sy2(a) = sy2(b)
                sz2(a) = sz2(b)
                sxy2(a) = sxy2(b)
                syz2(a) = syz2(b)
                szx2(a) = szx2(b)
                nodes2(b) = tmpNode
                sx2(b) = tmpSx
                sy2(b) = tmpSy
                sz2(b) = tmpSz
                sxy2(b) = tmpSxy
                syz2(b) = tmpSyz
                szx2(b) = tmpSzx
                foundNode = True
                Exit For
            End If
        Next b
        If foundNode = False Then
            MsgBox "Corrosponding nodes for node " + Str(nodes1(a)) + " not found. Rearrangement failed!", vbCritical + vbOKOnly, "Error!!"
            Exit Sub
        End If
    End If
Next a

ReDim sx3(nodesNo), sy3(nodesNo), sz3(nodesNo), sxy3(nodesNo), syz3(nodesNo), szx3(nodesNo)
ReDim minAlpha(nodesNo), maxAlpha(nodesNo)


' Determine Yield stress
If autoNo.Value = True Then
    yieldStress = Val(yldStrs.Text)
End If
If autoYes.Value = True Then
    yieldStress = 0
    For a = 1 To nodesNo
        tmpYeld = eqvStress(sx1(a), sy1(a), sz1(a), sxy1(a), syz1(a), szx1(a))
        If tmpYeld > yieldStress Then
            yieldStress = tmpYeld
        End If
        yldStrs.Text = Format$(yieldStress, "0.0000e+00")
    Next a
End If


' -------------------------------
For a = 1 To nodesNo
    sx3(a) = sx1(a) - sx2(a)
    sy3(a) = sy1(a) - sy2(a)
    sz3(a) = sz1(a) - sz2(a)
    sxy3(a) = sxy1(a) - sxy2(a)
    syz3(a) = syz1(a) - syz2(a)
    szx3(a) = szx1(a) - szx2(a)
Next a


' ********** determining beta ************
beta = 1
For a = 1 To nodesNo
    eqvStressValue = eqvStress(sx3(a), sy3(a), sz3(a), sxy3(a), syz3(a), szx3(a))
    If eqvStressValue > yieldStress Then
        probableBeta = yieldStress / eqvStressValue
        If probableBeta < beta Then
            beta = probableBeta
        End If
    End If
Next a
betaLab.Caption = Str(beta)


' ********** determining alpha ***********

If beta = 1 Then
    alpha = 1
    alphaLab.Caption = Str(alpha)
    'Exit Sub
End If

' Correcting the residual stress field
For a = 1 To nodesNo
    sx3(a) = sx3(a) * beta
    sy3(a) = sy3(a) * beta
    sz3(a) = sz3(a) * beta
    sxy3(a) = sxy3(a) * beta
    syz3(a) = syz3(a) * beta
    szx3(a) = szx3(a) * beta
Next a

' determining range of allowable alpha for the different nodes
For a = 1 To nodesNo
    minAlpha(a) = 1
    maxAlpha(a) = 0
    For thisAlpha = 0 To 1 Step Val(alphaStep.Text)
        tmpSx = sx3(a) + thisAlpha * sx2(a)
        tmpSy = sy3(a) + thisAlpha * sy2(a)
        tmpSz = sz3(a) + thisAlpha * sz2(a)
        tmpSxy = sxy3(a) + thisAlpha * sxy2(a)
        tmpSyz = syz3(a) + thisAlpha * syz2(a)
        tmpSzx = szx3(a) + thisAlpha * szx2(a)
        If eqvStress(tmpSx, tmpSy, tmpSz, tmpSxy, tmpSyz, tmpSzx) <= yieldStress Then ' Yield doesn't occur at this stress
            If thisAlpha < minAlpha(a) Then
                minAlpha(a) = thisAlpha
            End If
            If thisAlpha > maxAlpha(a) Then
                maxAlpha(a) = thisAlpha
            End If
        End If
    Next thisAlpha
Next a

' determine the common intersection of the ranges of alpha
highAlpha = 1
lowAlpha = 0
For a = 1 To nodesNo
    If minAlpha(a) > maxAlpha(a) Then
        MsgBox "Error!! minAlpha > maxAlpha", vbCritical + vbOKOnly
    End If
    isAlpha = findIntersection(lowAlpha, highAlpha, minAlpha(a), maxAlpha(a), lowAlpha, highAlpha)
    If isAlpha = False Then
        alphaLab.Caption = "No suitable alpha found!!"
        Exit Sub
    End If
Next a

alpha = highAlpha
alphaLab.Caption = Format$(alpha, "0.00000") + " [ Range: (" + Format$(lowAlpha, "0.00000") + ", " + Format$(highAlpha, "0.00000") + ") ]"

End Sub


Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Shift = 7 Then
    MsgBox "This code has been written and developed by Subhrajit Bhattacharya. email: subhrajit83@yahoo.co.in", vbInformation + vbOKOnly, "Note from developer"
End If
End Sub
